-- Angle in Radians
function getAngle(x1, y1, x2, y2)
   return math.atan2(y2 - y1, x2 - x1)
end

function getCirclesDistance(x1, y1, r1, x2, y2, r2)
   return math.sqrt(((x2 - x1) ^ 2) + ((y2 - y1) ^ 2)) - (r1 + r2)
end

function getOrbitX(x, angle, distance)
   return x + (distance * math.cos(angle))
end

function getOrbitY(y, angle, distance)
   return y + (distance * math.sin(angle))
end

function getOrbitPosition(x, y, angle, distance)
   local nx = x + (distance * math.cos(angle))
   local ny = y + (distance * math.sin(angle))
   
   return nx, ny
end

function getVelocityX(speed, angle)
   return speed * math.cos(angle)
end

function getVelocityY(speed, angle)
   return speed * math.sin(angle)
end

function getVelocityXY(speed, angle)
   local vx = speed * math.cos(angle)
   local vy = speed * math.sin(angle)
   
   return vx, vy
end