ranch = {}

function ranch.load()
   ranch.fence = newStaticEntity('images/ranch.png')
   ranch.fence.setPosition(love.graphics.getWidth() / 2, love.graphics.getHeight() / 2)
   
   ranch.sheep = {}
   
   for i = 1, 10 do
      ranch.spawnsheep()
   end
end

function ranch.update(dt)
   for _, v in pairs(ranch.sheep) do
      v.update(dt)
   end
end

function ranch.draw()
   ranch.fence.draw()
   for _, v in pairs(ranch.sheep) do
      v.draw()
   end
end

function ranch.spawnsheep()
   local lamb = newSheep(ranch.fence.x, ranch.fence.y)
      
   local idle = love.math.random(2)
   lamb.setAnimation('idle')
   if idle == 2 then lamb.sx = 1 else lamb.sx = -1 end
   
   local d = love.math.random(0, ranch.fence.radius - lamb.radius)
   local rx = love.math.random(love.graphics.getWidth())
   local ry = love.math.random(love.graphics.getHeight())
   local rr = math.atan2(ry - ranch.fence.y, rx - ranch.fence.x)
   
   local x = ranch.fence.x + (d * math.cos(rr))
   local y = ranch.fence.y + (d * math.sin(rr))
   
   lamb.setPosition(x, y)
   
   table.insert(ranch.sheep, lamb)
end