function newShepherd(x, y)
   local shepherd = newAnimatedEntity('images/shepherd.png', 20)

   shepherd.setPosition(x, y)
   
   shepherd.addAnimation('idle', 0.15)          shepherd.addAnimationFrames('idle', 1, 0, 41, 80, 11)
   shepherd.addAnimation('walking', 0.25)       shepherd.addAnimationFrames('walking', 1, 80, 51, 80, 4)
   shepherd.addAnimation('carry_idle', 0.5)     shepherd.addAnimationFrames('carry_idle', 0, 160, 49, 80, 2)
   shepherd.addAnimation('lifting', 0.11)       shepherd.addAnimationFrames('lifting', 0, 238, 76, 150, 4)
   shepherd.addAnimation('carry_walking', 0.25) shepherd.addAnimationFrames('carry_walking', 0, 388, 51, 80, 4)
   shepherd.addAnimation('dropping', 0.13)       shepherd.addAnimationFrames('dropping', 0, 470, 49, 80, 3)

   shepherd.setAnimation('idle')
   
   shepherd.speed = 70
   shepherd.target_x = shepherd.x
   shepherd.target_y = shepherd.y
   
   shepherd.vx = 0
   shepherd.vy = 0
   shepherd.isMoving = false
   shepherd.state = 'free'
   
   function shepherd.setTarget(x, y)
      shepherd.target_x = x
      shepherd.target_y = y
      
      local a = getAngle(shepherd.x, shepherd.y, x, y)
      shepherd.isMoving = true
      shepherd.vx, shepherd.vy = getVelocityXY(shepherd.speed, a)
      
      if shepherd.vx > 0 then shepherd.sx = 1 else shepherd.sx = -1 end
   end
   
   function shepherd.move(dt)
      if shepherd.isMoving then
         if shepherd.state == 'free' then
            shepherd.setAnimation('walking')
         elseif shepherd.state == 'carrying' then
            shepherd.setAnimation('carry_walking')
         end
         if getCirclesDistance(shepherd.x, shepherd.y, 5, shepherd.target_x, shepherd.target_y, 0) < 0 then
            if shepherd.state =='free' then shepherd.setAnimation('idle') else shepherd.setAnimation('carry_idle') end
            shepherd.x = shepherd.target_x
            shepherd.y = shepherd.target_y
            shepherd.isMoving = false
         else
            shepherd.x = shepherd.x + (shepherd.vx * dt)
            shepherd.y = shepherd.y + (shepherd.vy * dt)
         end
      end
   end
   
   return shepherd
end
