state_game_over = state_manager.newState(love.graphics.newFont(50))

function state_game_over.load()
   state_game_over.text = 'Game Over'
   state_game_over.width = state_game_over.font:getWidth(state_game_over.text)
   state_game_over.height = state_game_over.font:getHeight(state_game_over.text)
   
   state_game_over.items = newMenu(state_game_over.font, 5)
   state_game_over.items.addButton('Play Again', love.graphics.getWidth() / 2, 300,
      function()
         state_manager.pop()
         state_manager.pop()
         state_manager.push(state_game)
         state_manager.push(state_game_begin)
      end
   )
   state_game_over.items.addButton('Quit to Menu', love.graphics.getWidth() / 2, 400, function() state_manager.pop() state_manager.pop() end)
   
   love.mouse.setPosition(love.graphics.getWidth() / 2, 20)
end

function state_game_over.draw()
   love.graphics.setColor(1,1,1,0.5)
   state_game.draw()
   love.graphics.setColor(1,1,1,1)

   love.graphics.setFont(state_game_over.font)
   love.graphics.print(state_game_over.text, (love.graphics.getWidth() / 2) - (state_game_over.font:getWidth(state_game_over.text) / 2), 100)
   
   love.graphics.setFont(state_game_over.items.font)
   state_game_over.items.draw()
end

function state_game_over.keypressed(key)
   if key == 'up' or key == 'left' then
      state_game_over.items.cycle_up()
   elseif key == 'down' or key == 'right' then
      state_game_over.items.cycle_down()
   elseif key == 'space' or key == 'enter' then
      state_game_over.items.button_press()
   end
end
function state_game_over.keyreleased(key)
   if key =='space' or key == 'enter' then
      state_game_over.items.button_release()
   end
end

function state_game_over.mousemoved(x, y)
   state_game_over.items.mouse_over(x, y)
end
function state_game_over.mousepressed(x, y, button)
   if button == 1 then
      state_game_over.items.mouse_over(x, y)
      state_game_over.items.button_press()
   end
end
function state_game_over.mousereleased(x, y, button)
   if button == 1 then
      state_game_over.items.mouse_over(x, y)
      state_game_over.items.button_release()
   end
end
function state_game_over.wheelmoved(x, y)
   if y > 0 then
      state_game_over.items.cycle_up()
   elseif y < 0 then
      state_game_over.items.cycle_down()
   end
end