state_game_success = state_manager.newState(love.graphics.newFont(50))

function state_game_success.load()
   state_game_success.text = 'All Sheep are Secured!'
   state_game_success.width = state_game_success.font:getWidth(state_game_success.text)
   state_game_success.height = state_game_success.font:getHeight(state_game_success.text)
   
   state_game_success.items = newMenu(state_game_success.font, 5)
   state_game_success.items.addButton('Play Again', love.graphics.getWidth() / 2, 300,
      function()
         state_manager.pop()
         state_manager.pop()
         state_manager.push(state_game)
         state_manager.push(state_game_begin)
      end
   )
   state_game_success.items.addButton('Quit to Menu', love.graphics.getWidth() / 2, 400, function() state_manager.pop() state_manager.pop() end)
   
   love.mouse.setPosition(love.graphics.getWidth() / 2, 20)

   state_game_success.highscore = 200 - state_game.timer.ticks
   state_game_success.fast = 0
   for i = 10, 1, -1 do
      if state_game_success.highscore < state_highscores.list[i].score then
         state_game_success.fast = i
      end
   end
   
   if state_game_success.fast > 0 then
      for i = 10, state_game_success.fast + 1, -1 do
         state_highscores.list[i] = state_highscores.list[i - 1]
      end
      state_game_success.winner = ''  
   end
end

function state_game_success.draw()
   love.graphics.setColor(1,1,1,0.5)
   state_game.draw()
   love.graphics.setColor(1,1,1,1)

   love.graphics.setFont(state_game_success.font)
   love.graphics.print(state_game_success.text, (love.graphics.getWidth() / 2) - (state_game_success.font:getWidth(state_game_success.text) / 2), 50)
   
   if state_game_success.fast > 0 then
      love.graphics.print('Time Score: ' .. state_game_success.highscore, (love.graphics.getWidth() / 2) - (state_game_success.font:getWidth('Time Score: ' .. state_game_success.highscore) / 2), 110)
      love.graphics.print(state_game_success.winner .. '_', (love.graphics.getWidth() / 2) - (state_game_success.font:getWidth(state_game_success.winner) / 2), 160)
   else
      state_game_success.items.draw()
   end
end

function state_game_success.keypressed(key)
   if state_game_success.fast > 0 then
      if key == 'backspace' then
         state_game_success.winner = state_game_success.winner:sub(1, state_game_success.winner:len() - 1)
      elseif key == 'return' then
         if state_game_success.winner == '' then
            state_game_success.winner = 'Bugkalot'
         end
         state_highscores.list[state_game_success.fast] = {name = state_game_success.winner, score = state_game_success.highscore}
         state_highscores.savelist()
         state_game_success.fast = 0
      end
   else
      if key == 'up' or key == 'left' then
         state_game_success.items.cycle_up()
      elseif key == 'down' or key == 'right' then
         state_game_success.items.cycle_down()
      elseif key == 'space' or key == 'return' then
         state_game_success.items.button_press()
      end
   end
end
function state_game_success.keyreleased(key)
   if state_game_success.fast == 0 then
      if key =='space' or key == 'return' then
         state_game_success.items.button_release()
      end
   end
end
function state_game_success.textinput(t)
   if state_game_success.fast > 0 and state_game_success.winner:len() < 9 then
      state_game_success.winner = state_game_success.winner .. t
   end
end

function state_game_success.mousemoved(x, y)
   if state_game_success.fast == 0 then
      state_game_success.items.mouse_over(x, y)
   end
end
function state_game_success.mousepressed(x, y, button)
   if button == 1 and state_game_success.fast == 0 then
      state_game_success.items.mouse_over(x, y)
      state_game_success.items.button_press()
   end
end
function state_game_success.mousereleased(x, y, button)
   if button == 1 and state_game_success.fast == 0 then
      state_game_success.items.mouse_over(x, y)
      state_game_success.items.button_release()
   end
end
function state_game_success.wheelmoved(x, y)
   if y > 0 and state_game_success.fast == 0 then
      state_game_success.items.cycle_up()
   elseif y < 0 and state_game_sucess.fast == 0 then
      state_game_success.items.cycle_down()
   end
end
