state_highscores = state_manager.newState(love.graphics.newFont(50))
state_highscores.list = {}

function state_highscores.load()
   state_highscores.text = 'Fastest Times'
   state_highscores.items = newMenu(love.graphics.newFont(25), 5)
   state_highscores.items.addButton('Back', love.graphics.getWidth() / 2, 550, function() state_manager.pop() end)
   
   state_highscores.minifont = love.graphics.newFont(30)
end

function state_highscores.draw()
   love.graphics.setFont(state_highscores.font)
   love.graphics.print(state_highscores.text, (love.graphics.getWidth() / 2) - (state_highscores.font:getWidth(state_highscores.text) / 2), 10)

   love.graphics.setFont(state_highscores.minifont)
   for i = 1, 10 do
      love.graphics.print(state_highscores.list[i].name, 280,  100 + (40 * (i - 1)))
      love.graphics.print(state_highscores.list[i].score, 470, 100 + (40 * (i - 1)))
   end
   
   state_highscores.items.draw()
end

function state_highscores.keypressed(key)
   if key == 'escape' then
      state_manager.pop()
   elseif key == 'up' or key == 'down' or key == 'left' or key == 'right' then
      state_highscores.items.cycle_up()
   elseif key == 'space' or key == 'enter' then
      state_highscores.items.button_press()
   end
end
function state_highscores.keyreleased(key)
   if key == 'space' or key == 'enter' then
      state_highscores.items.button_release()
   end
end

function state_highscores.mousepressed(x, y, button)
   state_highscores.items.mouse_over(x, y)
   if button == 1 then
      state_highscores.items.button_press()
   end
end
function state_highscores.mousereleased(x, y, button)
   state_highscores.items.mouse_over(x, y)
   if button == 1 then
      state_highscores.items.button_release()
   end
end
function state_highscores.mousemoved(x, y)
   state_highscores.items.mouse_over(x, y)
end
function state_highscores.wheelmoved(x, y)
   state_highscores.items.cycle_up()
end

function state_highscores.loadlist()

   if love.filesystem.getInfo('Scores.txt') then
      local lines = {}

      -- Putting the each line in the lines table
      for line in love.filesystem.lines('Scores.txt') do
         table.insert(lines, line)
      end
      
      -- For each line, lets...
      for i = 1, #lines do
         --1. Divide each line into separate words
         local words = {}

         --   Each word is divided by whitespaces
         for word in lines[i]:gmatch('%S+') do
            table.insert(words, word)
         end
         
         --2. Add the values in the highscores list
         table.insert(state_highscores.list, { -- There are only 2 words: the 'name' and the 'score'
            name = words[1],
            score = tonumber(words[2])
         })
      end
   else
      for i = 1, 10 do
         table.insert(state_highscores.list, {name = 'Bugkalot', score = 199})
      end
   end
end

function state_highscores.savelist()
   local new_highscorelist = '' -- It's gonna be a big string

   for i = 1, #state_highscores.list do
      new_highscorelist = new_highscorelist
         .. state_highscores.list[i].name
         .. ' '
         .. state_highscores.list[i].score
         .. '\n'
   end

   love.filesystem.write('Scores.txt', new_highscorelist)
end
