state_menu = state_manager.newState(love.graphics.newFont(40))

function state_menu.load()
   state_menu.title_font = love.graphics.newFont(80)
   state_menu.title_text = 'Clumsy Shepherd'
   state_menu.title_width = state_menu.title_font:getWidth(state_menu.title_text) / 2
   
   state_menu.items = newMenu(state_menu.font, 5)
   state_menu.items.addButton('Play', love.graphics.getWidth() / 2, 300,
      function()
         state_manager.push(state_game)
         state_manager.push(state_game_begin)
      end
   )
   state_menu.items.addButton('Fastest Times', love.graphics.getWidth() / 2, 400,
      function()
         state_manager.push(state_highscores)
      end
   )
   state_menu.items.addButton('Exit', love.graphics.getWidth() / 2, 500, function() love.event.quit() end)
   
   state_highscores.loadlist()
end

function state_menu.update(dt)
   
end

function state_menu.draw()
   love.graphics.setBackgroundColor(0, 0, 0, 1)
   love.graphics.setFont(state_menu.title_font)
   love.graphics.print(state_menu.title_text, (love.graphics.getWidth() / 2) - state_menu.title_width, 100)
   
   love.graphics.setFont(state_menu.font)
   state_menu.items.draw()
end

function state_menu.keypressed(key)
   if key == 'escape' then
      state_manager.pop()
   elseif key == 'up' or key == 'left' then
      state_menu.items.cycle_up()
   elseif key == 'down' or key == 'right' then
      state_menu.items.cycle_down()
   elseif key == 'space' or key == 'enter' then
      state_menu.items.button_press()
   end
end
function state_menu.keyreleased(key)
   if key == 'space' or key == 'enter' then
      state_menu.items.button_release()
   end
end

function state_menu.mousemoved(x, y, dx, dy)
   state_menu.items.mouse_over(x, y)
end
function state_menu.mousepressed(x, y, button)
   if button == 1 then
      state_menu.items.mouse_over(x, y)
      state_menu.items.button_press()
   end
end
function state_menu.mousereleased(x, y, button)
   if button == 1 then
      state_menu.items.mouse_over(x, y)
      state_menu.items.button_release()
   end
end
function state_menu.wheelmoved(x, y)
   if y > 0 then
      state_menu.items.cycle_up()
   elseif y < 0 then
      state_menu.items.cycle_down()
   end
end
