require 'libraries/maths'
require 'libraries/entities'
require 'libraries/menu'
require 'libraries/state_manager'

require 'libraries/state_menu'
require 'libraries/state_highscores'
require 'libraries/state_game'
require 'libraries/state_game_begin'
require 'libraries/state_game_over'
require 'libraries/state_game_success'
require 'libraries/state_pause'

require 'libraries/timer'
require 'libraries/ranch'
require 'libraries/field'
require 'libraries/sheep'
require 'libraries/shepherd'

function love.load()
   state_manager.push(state_menu)
end

function love.update(dt)
   state_manager.update(dt)
end

function love.draw()
   state_manager.draw()
end

function love.keypressed(key)
   state_manager.keypressed(key)
end
function love.keyreleased(key)
   state_manager.keyreleased(key)
end
function love.textinput(t)
   state_manager.textinput(t)
end

function love.mousemoved(x, y, dx, dy)
   state_manager.mousemoved(x, y)
end
function love.mousepressed(x, y, button)
   state_manager.mousepressed(x, y, button)
end
function love.mousereleased(x, y, button)
   state_manager.mousereleased(x, y, button)
end
function love.wheelmoved(x, y)
   state_manager.wheelmoved(x, y)
end